package 
{
  import flash.display.BitmapData;
  import flash.display.Graphics;
  import flash.display.Sprite;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.filters.BlurFilter;
  import flash.geom.Matrix;
  import flash.geom.Point;
  import flash.geom.Rectangle;
  import flash.ui.Keyboard;
  import flash.utils.Dictionary;


	public class Main extends xGame 
	{

		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
  
    

    [Embed(source = "minifont8.png")]  private static var embedFontPic8:Class;
    [Embed(source = "minifont8.xfnt", mimeType = "application/octet-stream")]
    private static var embedFont8:Class;
   
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
      
      stage.quality = "LOW";
    
 
      myAdvFont = new xAdvFont();
      myAdvFont.loadFont(embedFont8, embedFontPic8);
      
      
      //draw a preimage 
      //because need to trick people to click on the window
      //to be in focus to use keyboard 
      drawImageSpr(graphics, (new embedStart).bitmapData, 0, 0, false, false);
        
      filters = [ new BlurFilter() ];
        gameState = 2;
   
       
      stage.addEventListener(MouseEvent.MOUSE_DOWN, onMdown);
      stage.addEventListener(MouseEvent.MOUSE_UP, onMup);
      stage.addEventListener(KeyboardEvent.KEY_DOWN, onKdown);
      stage.addEventListener(KeyboardEvent.KEY_UP, onKup);
      stage.addEventListener(Event.ENTER_FRAME, onEnter);   
		}//init
   
      public var myAdvFont:xAdvFont;

      [Embed(source="startimage.png")]  private static var embedStart:Class;

    [Embed(source = "map1.png")]   private static var embedMap1:Class;
    [Embed(source = "map2.png")]   private static var embedMap2:Class;
    [Embed(source = "map3.png")]   private static var embedMap3:Class;
    [Embed(source = "map4.png")]   private static var embedMap4:Class;
    [Embed(source = "map5.png")]   private static var embedMap5:Class;
    [Embed(source = "map6.png")]   private static var embedMap6:Class;
    [Embed(source = "map7.png")]   private static var embedMap7:Class;
    [Embed(source = "secretending.png")]  private static var embedMap8:Class;
    
    

    
    public function loadMap():void
    {
      vx = 0; vy = 0;
      
      if (curMap == 0)
      {
        mapImage = (new embedMap1).bitmapData;
         cx = 100; cy = 80;
         gx = 540; gy = 410;
      }
      else if (curMap == 1)
      {
          mapImage = (new embedMap2).bitmapData;
         cx = 524; cy = 85;
         gx = 560; gy = 280;
      }
       else if (curMap == 2)
      {
          mapImage = (new embedMap3).bitmapData;
         cx = 576; cy = 430;
         gx = 118; gy = 90;
      }
      else if (curMap == 3)
      {
          mapImage = (new embedMap4).bitmapData;
         cx = 95; cy = 110;
         gx = 545; gy = 300;
      }
      else if (curMap == 4)
      {
          mapImage = (new embedMap5).bitmapData;
         cx = 120; cy = 110;
         gx = 530; gy = 100;
      }
      else if (curMap == 5)
      {
          mapImage = (new embedMap6).bitmapData;
         cx = 525; cy = 358;
         gx = 290 ; gy = 90 ;
      }
     else if (curMap == 6)
      {
          mapImage = (new embedMap7).bitmapData;
         cx = 100; cy = 300;
         gx = 560; gy = 370;
      }
      else if (curMap == 99)
      {
          mapImage = (new embedMap8).bitmapData;
         cx = 100; cy = 300;
         gx = 560; gy = 370;
      }
      else 
      {
    
        curMap = 0; gameState = 1; 
      }//endif
      
      
    }//loadmap  

    public var gameState:int = 0;
    public var curMap:int = 0;
  
    public var cx:Number = 0;
    public var cy:Number = 0;
    public var rad:Number = 8;
    public var vx:Number = 0;
    public var vy:Number = 0;
    
    public var gx:Number = 0;
    public var gy:Number = 0;
    
    public var mapImage:BitmapData;
    
    public function isWall(ax:Number, ay:Number):Boolean
    {  
      if (isLava(ax, ay)) { return false; }
      return (mapImage.getPixel32(ax, ay) > 256); 
    }
    
    public function isLava(ax:Number, ay:Number):Boolean
    {   return (mapImage.getPixel(ax, ay) == 0xFF0000 );  }
    
    
    public function getDist(ax:Number, ay:Number):Number
    { return Math.sqrt(ax * ax + ay * ay); }
 

    public function onEnter(e:Event):void
    {  
      if (gameState == 2)
      {
        if (mbutton > 0) { gameState = 1; filters = []; }
        return;  
      }
      
      if (gameState == 1)
      {
        loadMap(); gameState = 0; return;
      }//endif
      
      if (isKeyPress(Keyboard.F5)) { gameState = 1; curMap += 1; }
      
      if (cy > 500) { gameState = 1; curMap = 99; }
      
      var ms:Number;
      ms = 0.3;
      
      vy += 0.3;
      
      if (isKeyDown(Keyboard.LEFT)) { vx -= ms; }
      if (isKeyDown(Keyboard.RIGHT)) { vx += ms; }
      
      
      vx *= 0.97; //vy *= 0.999;
      cx += vx; cy += vy;
     
      if (isLava(cx, cy)) { gameState = 1; }
        
      if (vx > 0 && isWall(cx + rad, cy)) { vx *= -0.5; }
      if (vx < 0 && isWall(cx - rad, cy)) { vx *= -0.5; }
      if (vy > 0 && isWall(cx, cy + rad)) { vy = -7; }
      if (vy < 0 && isWall(cx, cy - rad)) { vy = 0; }
      
    
      
      if (getDist(cx - gx, cy - gy) < 32) { gameState = 1; curMap += 1; }
      
      graphics.clear();
      
      drawImageSpr(graphics, mapImage, 0, 0, false, false);
      
      graphics.lineStyle(2, 0);
      graphics.beginFill(0xFF0000, 1);
       graphics.drawCircle(cx, cy, rad);
      graphics.endFill();

      
      var i:int;
      var ax:Number; var ay:Number; var ta:Number;
      var d:Number;
      d = (Math.sin(gt*0.05)+1) * 16+4;
      for (i = 0; i < 16; i += 1)
      {
          ta = (i*0.2 + gt*0.3) * 2;
          ax = gx + Math.cos(ta) * d; ay = gy + Math.sin(ta) * d;
         graphics.beginFill(0xFF, 1);
           graphics.drawCircle(ax, ay, 4);
          graphics.endFill();
      }//nexti
      
      
      //trace(mapImage.getPixel(stage.mouseX, stage.mouseY));

       gt += 1;
       keyTime += 1;
    }//onenter
    
    
   
 

 
  }//classend
}


